#include "dude.h"
#include "map.h"
#include <cstring>

Dude::Dude(const Coord &_pos, Map &_map, int &_team) :
    m_pos(_pos),
    m_map(_map),
    m_team(_team),
    m_dead(false),
    m_success(true),
    m_inventory(-1)
{
    std::memset(&m_memory, 0, DUDE_MEMORY_SIZE);
}

char* Dude::getMemory()
{
    return m_memory;
}

void Dude::move(Dir d)
{
    m_pos += Coord(d);
    m_pos.x %= m_map.getWidth();
    m_pos.y %= m_map.getHeight();
}

void Dude::receiveComData(const Com &comData)
{
    std::memcpy(&m_comData, &comData, sizeof(Com));
}

int Dude::getNear(Dir d)
{
    return m_map[Coord(d) + m_pos].type;
}

int Dude::getInfo(Dir d)
{
    return m_map[Coord(d) + m_pos].data.nbRes;
}
